(in-package "GATLOPP")

(defparameter *quit* nil)

(defun draw-textbox (win gc startx starty y-inc &rest strings)
  (loop for y from starty by y-inc
	for str in strings
	do (xlib:draw-glyphs win gc startx y str)))


(defun top-loop ()
  (let ((key nil))
    (activate-map 0)
    (draw-map)
    (draw-textbox graphics:*background* graphics:*gcontext-set* 200 200 10 "p - play" "h - help" "q - quit")
    (draw graphics:*game-window*)
    (loop until *quit*
	  do (progn
	       (xlib:event-case
	           (*display* :timeout 1)
	         (:key-press (window code)
		   (my-ignore window)
		   (let ((k (xlib:keycode->keysym graphics:*display* code 0)))
		     (case k
		       ((#x0068 #x0070 #x0071) (setf key (code-char k)))
		       (t (setf key nil))))))
	       (when key
		 (case key
		   (#\p
		    (setf graphics:*game-over* nil)
		    (activate-map 1)
		    (draw-map)
		    (draw *game-window*)
		    (xlib:display-force-output *display*)
		    (graphics:interaction-loop)
		    (activate-map 0)
		    (draw-map)
		    (draw-textbox *background* *gcontext-set* 200 200 10 "p - play" "h - help" "q - quit")
		    (draw *game-window*))
		   (#\h nil)
		   (#\q (setf *quit* t))))))))

(defun start-gatlopp ()
  (maps:read-all-maps)
  (activate-map 0)
  (load-images)
  (draw-map)
  (draw *game-window*)
  (xlib:display-force-output *display*)
  (ensure-animations)
  (top-loop))
